Attribute VB_Name = "ComDlgColor"
'    
Option Explicit


'API
Declare Function ChooseColor Lib "comdlg32.dll" _
Alias "ChooseColorA" (pChoosecolor As _
ChooseColor) As Long

'  
Global Const TOTAL_CUSTOM_COLORS = 16

' 
Global CustomColors(TOTAL_CUSTOM_COLORS * 4 - 1) As Byte

'   
Type ChooseColor
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type


Function ShowColorDialog(hWnd As Long, Flags As Long) As Long
'
Dim CClr As ChooseColor
Dim I As Integer

'   
CClr.lStructSize = Len(CClr)
' 
CClr.hwndOwner = hWnd
' instance 
CClr.hInstance = App.hInstance
'   (  Unicode)
CClr.lpCustColors = StrConv(CustomColors, vbUnicode)
'
CClr.Flags = Flags

' 
If ChooseColor(CClr) <> 0 Then
    '  ,   
    ShowColorDialog = CClr.rgbResult
    ' 
    For I = 0 To TOTAL_CUSTOM_COLORS * 4 - 1
        CustomColors(I) = Asc(Mid(CClr.lpCustColors, I + 1, 1))
    Next I
Else
    '  -1
    ShowColorDialog = -1
End If
End Function

