Attribute VB_Name = "SelectDirectoryModule"
Option Explicit

Declare Function SHBrowseForFolder Lib _
"shell32.dll" (BInfo As BrowseInfo) As Long

Declare Function SHGetPathFromIDList Lib _
"shell32.dll" (ByVal List As Long, ByVal Buffer _
As String) As Long

Declare Function lstrcat Lib "kernel32.dll" Alias _
"lstrcatA" (ByVal String1 As String, ByVal _
String2 As String) As Long

Private Type BrowseInfo
    Owner As Long
    ListRoot As Long
    DisplayName As Long
    Title As Long
    Flags As Long
    CallBack As Long
    Param As Long
    Image As Long
End Type

Function SelectDir(SelectDirProgramHWND As Long, Caption As String, SelectDirFlags As Long) As String
On Error Resume Next
Dim DList As Long
Dim Buffer As String
Dim BI As BrowseInfo

With BI
    .Owner = SelectDirProgramHWND
    .Title = lstrcat(Caption, "")
    .Flags = SelectDirFlags
End With

DList = SHBrowseForFolder(BI)

If (DList) Then
    Buffer = Space(260)
    SHGetPathFromIDList DList, Buffer
    Buffer = Left(Buffer, InStr(Buffer, vbNullChar) - 1)
    If Len(Buffer) > 0 Then
        If Right(Buffer, 1) = "\" Then
            SelectDir = Buffer
        Else
            SelectDir = Buffer + "\"
        End If
    End If
End If
End Function


